#include "pgw.h"

double baselinewidth=1.0;
PGP defpgp;
int deffont=HELV;
int defslant=RM;


void SetBaseLineWidth(double width){
    baselinewidth=width;
}
double BaseLineWidth(){
    return baselinewidth;
}

void SetDefaultFontFamily(int font){
    deffont=font;
}
int DefaultFontFamily(){
    return deffont;
}
void SetDefaultSlant(int slant){
    defslant=slant;
}
int DefaultSlant(){
    return defslant;
}


void InitializePGP()
{
    defpgp.ptype=CIR;  defpgp.ltype=SOL;
    defpgp.flush=CENTER;  defpgp.rot=R0;
    defpgp.rad=DFRAD;  defpgp.pt=DFPOINT;
    defpgp.arrow=DFARROW;  defpgp.angle=DFARANGLE;
    defpgp.width=1.0;
    PGGetNamedColor(DFCOLOR, &(defpgp.pgcl));
}






void SetDefaultPointType(int type){
    defpgp.ptype=type;
}
int DefaultPointType(){
    return defpgp.ptype;
}
void SetDefaultLineType(int type){
    defpgp.ltype=type;
}
int DefaultLineType(){
    return defpgp.ltype;
}

void SetDefaultPoint(double pt){
    defpgp.pt=pt;
}
double DefaultPoint(){
    return defpgp.pt;
}
void SetDefaultRadius(double rad){
    defpgp.rad=rad;
}
double DefaultRadius(){
    return defpgp.rad;
}
void SetDefaultArrow(double arrow){
    defpgp.arrow=arrow;
}
double DefaultArrow(){
    return defpgp.arrow;
}
void SetDefaultArrowAngle(double angle){
    defpgp.angle=angle;
}
double DefaultArrowAngle(){
    return defpgp.angle;
}
void SetDefaultLineWidth(double width){
    if(width<0.0) width=0.0;
    defpgp.width=width;
}
double DefaultLineWidth(){
    return defpgp.width;
}
void SetDefaultColor(PGColor pgcl){
    defpgp.pgcl=pgcl;
}
PGColor DefaultColor(){
    return defpgp.pgcl;
}


/* PGProperties */

PGP GetPGP(){
    return defpgp;
}
