#include <stdlib.h>
#include "pgw.h"


void FreePGObjectList(PGObjectList* pgl){
    free(pgl);
}
void FreePGObjectLists(PGObjectList* pgl)
{
    PGObjectList* pgl1;
    while(pgl->next){
        pgl1=pgl->next;
        pgl->next=pgl1->next;
        FreePGObjectList(pgl1);
    }
}


void FreePGPoints(PGPoints* pg){
#ifdef USE_MEMORY_COPY
    if(pg->x1) free(pg->x1);
    if(pg->x2) free(pg->x2);
    if(pg->x3) free(pg->x3);
#endif
    free(pg);
}
void FreePGLine(PGLine* pg){
#ifdef USE_MEMORY_COPY
    if(pg->x1) free(pg->x1);
    if(pg->x2) free(pg->x2);
    if(pg->x3) free(pg->x3);
#endif
    free(pg);
}
void FreePGString(PGString* pg){
    if(pg->str) free(pg->str);
    free(pg);
}
void FreePGFixString(PGFixString* pg){
    if(pg->str) free(pg->str);
    free(pg);
}
void FreePGArrows(PGArrows* pg){
#ifdef USE_MEMORY_COPY
    if(pg->x1) free(pg->x1);
    if(pg->x2) free(pg->x2);
    if(pg->x3) free(pg->x3);
    if(pg->v1) free(pg->v1);
    if(pg->v2) free(pg->v2);
    if(pg->v3) free(pg->v3);
#endif
    free(pg);
}
void FreePGObject(PGObject* pg)
{
    switch(pg->type){
      case PGPOINTS:
        FreePGPoints((PGPoints*)pg);
        break;
      case PGLINE:
        FreePGLine((PGLine*)pg);
        break;
      case PGSTRING:
        FreePGString((PGString*)pg);
        break;
      case PGFIXSTRING:
        FreePGFixString((PGFixString*)pg);
        break;
      case PGARROWS:
        FreePGArrows((PGArrows*)pg);
        break;
    }
}
