#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include "pointer.h"

int err=FALSE;

void StripComments(char* str)
{
    int i;
    char quote=0;
    for(i=0; str[i]!='\0'; i++){
        if(str[i]=='\\'){
            if(str[i+1]!='\0') i++;
        }else if(quote){
            if(str[i]==quote) quote=0;
        }else if(IsQuote(str[i])){
            quote=str[i];
        }else if(str[i]=='#'){
            if(str[strlen(str)-1]=='\n'){
                str[i]='\n';  str[i+1]='\0';
            }else{
                str[i]='\0';
            }
            return;
        }
    }
}
void StripSpaces(char** str)
{
    char* buf;
    buf=(*str);
    while(*buf==' ' || *buf=='\t') buf++;
    *str=buf;
    if(*buf=='\0') return;
    while(*buf!='\0') buf++;
    buf--;
    while(*buf==' ' || *buf=='\t') buf--;
    *(buf+1)='\0';
}
void StripCharacters(char* c, char** str)
{
    int j;
    char* buf;
    buf=(*str);
    while(TRUE){
        for(j=0; c[j]!='\0'; j++){
            if(*buf==c[j]) break;
        }
        if(c[j]=='\0') break;
        buf++;
    }
    *str=buf;
    if(*buf=='\0') return;
    while(*buf!='\0') buf++;
    buf--;
    while(TRUE){
        for(j=0; c[j]!='\0'; j++){
            if(*buf==c[j]) break;
        }
        if(c[j]=='\0') break;
        buf--;
    }
    *(buf+1)='\0';
}
void StripNewLines(int* ns, int* ne, char** str)
{
    char* buf;
    buf=(*str);
    while(TRUE){
        if(*buf=='\n'){
            buf++;  (*ns)++;
        }else if(*buf==' ' || *buf=='\t'){
            buf++;
        }else{
            break;
        }
    }
    *str=buf;
    if(*buf=='\0') return;
    while(*buf!='\0') buf++;
    buf--;
    while(TRUE){
        if(*buf=='\n'){
            buf--;  (*ne)--;
        }else if(*buf==' ' || *buf=='\t'){
            buf--;
        }else{
            break;
        }
    }
    *(buf+1)='\0';
}
void TabToSpace(char* str)
{
    int i;
    for(i=0; str[i]!='\0'; i++){
        if(str[i]=='\t') str[i]=' ';
    }
}

int Parentheses(char* str)
{
    int i;
    int nb=0;
    char quote=0;
    char pair=0;
    for(i=0; str[i]!='\0'; i++){
        if(str[i]=='\\'){
            if(str[i+1]!='\0') i++;
        }else if(quote){
            if(str[i]==pair){
                nb--;
                if(nb==0) quote=0;
            }else if(str[i]==quote){
                nb++;
            }
        }else if(IsQuote(str[i]) || IsLeftParentheses(str[i])){
            nb=1;  quote=str[i];  pair=OtherParentheses(str[i]);
        }else if(IsRightParentheses(str[i])){
            break;
        }
    }
    return nb;
}

int SearchFromEnd(int* line, int n, char* key, char* str)
{
    int i, j;
    int nb=0;
    char quote=0;
    char pair=0;
    for(i=n; 0<=i; i--){
        if(str[i]=='\n') (*line)--;
        if(0<i && str[i-1]=='\\'){
        }else if(quote){
            if(str[i]==pair){
                nb--;
                if(nb==0){
                    quote=0;
                    for(j=0; key[j]!='\0'; j++){
                        if(key[j]==str[i]) return i;
                    }
                }
            }else if(str[i]==quote){
                nb++;
            }
        }else if(IsQuote(str[i]) || IsRightParentheses(str[i])){
            for(j=0; key[j]!='\0'; j++){
                if(key[j]==str[i]) return i;
            }
            nb=1;  quote=str[i];  pair=OtherParentheses(str[i]);
        }else if(IsLeftParentheses(str[i])){
            char msg[256];
            sprintf(msg, E_Unmatch, str[i]);
            ParseError(*line, msg);
            err=TRUE;
            return i;
        }else{
            for(j=0; key[j]!='\0'; j++){
                if(key[j]==str[i]) return i;
            }
        }
    }
    if(quote){
        char msg[256];
        sprintf(msg, E_Unmatch, quote);
        ParseError(*line, msg);
        err=TRUE;
        return i;
    }
    return i;
}
int SearchFromBegining(int* line, int n, char* key, char* str)
{
    int i, j;
    int nb=0;
    char quote=0;
    char pair=0;
    for(i=n; str[i]!='\0'; i++){
        if(str[i]=='\\'){
            if(str[i+1]!='\0') i++;
        }else if(quote){
            if(str[i]==pair){
                nb--;
                if(nb==0){
                    quote=0;
                    for(j=0; key[j]!='\0'; j++){
                        if(key[j]==str[i]) return i;
                    }
                }
            }else if(str[i]==quote){
                nb++;
            }
        }else if(IsQuote(str[i]) || IsLeftParentheses(str[i])){
            for(j=0; key[j]!='\0'; j++){
                if(key[j]==str[i]) return i;
            }
            nb=1;  quote=str[i];  pair=OtherParentheses(str[i]);
        }else if(IsRightParentheses(str[i])){
            char msg[256];
            sprintf(msg, E_Unmatch, str[i]);
            ParseError(*line, msg);
            err=TRUE;
            return i;
        }else{
            for(j=0; key[j]!='\0'; j++){
                if(key[j]==str[i]) return i;
            }
        }
        if(str[i]=='\n') (*line)++;
    }
    if(quote){
        char msg[256];
        sprintf(msg, E_Unmatch, quote);
        ParseError(*line, msg);
        err=TRUE;
        return i;
    }
    return i;
}

Node* ParseToElement(int ns, int ne, char* str)
{
    Node* ret;
    StripNewLines(&ns, &ne, &str);
    if(str[0]=='\0') return NULL;
    ret=AllocateNode();
    ret->type=N_Element;
    ret->el=ToElement(str);
    return ret;
}
Node* ParseList(int ns, int ne, char* str)
{
    int i, ls=ns, le=ns;
    Node* nd;
    Node* node;
    Element* el;
    List* list;
    list=ToList(NULL);
    StripNewLines(&le, &ne, &str);
    if(str[0]=='\0') return NULL;
    while(*str!='\0'){
        ls=le;
        i=SearchFromBegining(&le, 0, ",", str);
        if(err){
            FreeTmpList(list);
            err=FALSE;
            return NULL;
        }else if(str[i]==','){
            str[i]='\0';  i++;
            nd=ParseSemicolon(ls, le, str);
            el=(Element*)nd;
            AddToList(list, el);
            str+=i;
            StripNewLines(&le, &ne, &str);
            if(*str=='\0') AddToList(list, NULL);
        }else{
            nd=ParseSemicolon(ls, le, str);
            el=(Element*)nd;
            AddToList(list, el);
            str+=i;
            StripNewLines(&le, &ne, &str);
        }
    }
    if(ListLength(list)==1){
        if(IsNode(list->next->el)){
            node=(Node*)(list->next->el);
        }else{
            node=AllocateNode();
            node->type=N_Element;
            node->el=list->next->el;
        }
        free(list);
    }else{
        node=AllocateNode();
        node->type=N_Element;
        node->el=(Element*)list;
    }
    return node;
}
Node* ParseFunction(int ns, int ne, char* str)
{
    int i=0, ls=ns, le=ns;
    Node* nd;
    Node* node;
    Element* el;
    List* list;
    while(IsWord(str[i])) i++;
    if(str[i]!='(') return NULL;
    str[strlen(str)-1]='\0';
    str[i]='\0';
    list=ToList(NULL);
    AddToList(list, StringElement(str));
    str+=i+1;
    StripNewLines(&le, &ne, &str);
    while(*str!='\0'){
        ls=le;
        i=SearchFromBegining(&le, 0, ",", str);
        if(err){
            FreeTmpList(list);
            err=FALSE;
            return NULL;
        }else if(str[i]==','){
            str[i]='\0';  i++;
        }
        nd=ParseSemicolon(ls, le, str);
        if(nd && nd->type==N_Element){
            el=nd->el;  free(nd);
        }else{
            el=(Element*)nd;
        }
        AddToList(list, el);
        str+=i;
        StripNewLines(&le, &ne, &str);
    }
    node=AllocateNode();
    node->type=N_Command;
    node->el=(Element*)list;
    return node;
}
Node* ParseTerm(int ns, int ne, char* str)
{
    int i, line;
    char msg[256];
    Node* node;
    StripNewLines(&ns, &ne, &str);
    if(str[0]=='\0') return NULL;
    i=strlen(str)-1;  line=ne;
    if(str[i]==']'){
        i=SearchFromEnd(&line, i, "[", str);
        if(err){
            err=FALSE;
            return NULL;
        }else if(i==0){
            sprintf(msg, E_NoLTerm, "[]");
            ParseError(line, msg);
            return NULL;
        }else if(i<0){
            return NULL;
        }
        str[strlen(str)-1]='\0';  str[i]='\0';
        node=AllocateNode();
        node->type=N_Index;
        node->left =ParseTerm(ns, line, str);
        node->right=ParseSemicolon(line, ne, str+i+1);
        return node;
    }else if(str[i]=='}'){
        i=SearchFromEnd(&line, i, "{", str);
        if(err){
            err=FALSE;
            return NULL;
        }else if(i==0){
            str[strlen(str)-1]='\0';  str++;
            node=AllocateNode();
            node->type=N_Element;
            node->el=BlockElement(ParseSemicolon(ns, ne, str));
            return node;
        }else if(i<0){
            return NULL;
        }
        str[strlen(str)-1]='\0';  str[i]='\0';
        node=AllocateNode();
        node->type=N_Key;
        node->left =ParseTerm(ns, line, str);
        if(node->left==NULL){
            free(node);
            return ParseSemicolon(line, ne, str+i+1);
        }
        node->right=ParseSemicolon(line, ne, str+i+1);
        return node;
    }else if(str[i]==')'){
        i=SearchFromEnd(&line, i, "(", str);
        if(i==0){
            str[strlen(str)-1]='\0';  str++;
            node=ParseList(ns, ne, str);
            return node;
        }else if(i<0){
            return NULL;
        }else if(IsFunctionForm(str, i-1)){
            return ParseFunction(ns, ne, str);
        }else{
            sprintf(msg, E_ExTermBF, "()");
            ParseError(line, msg);
            return NULL;
        }
    }
    i=SearchFromEnd(&line, i, ".", str);
    if(err){
        err=FALSE;
        return NULL;
    }
    if(i<=0) return ParseToElement(ns, ne, str);
    if(!isalpha(str[i+1])) return ParseToElement(ns, ne, str);
    str[i]='\0';
    node=AllocateNode();
    node->type=N_Period;
    node->left=ParseTerm(ns, line, str);
    node->el=StringElement(str+i+1);
    return node;
}
Node* ParsePow(int ns, int ne, char* str)
{
    int i, line;
    char msg[256];
    Node* node;
    StripNewLines(&ns, &ne, &str);
    if(str[0]=='\0') return NULL;
    if(str[0]=='^'){
        return ParseToElement(ns, ne, str);
    }
    i=strlen(str)-1;  line=ne;
    if(str[i]=='^'){
        return ParseToElement(ns, ne, str);
    }
    i=SearchFromEnd(&line, i, "^", str);
    if(err){
        err=FALSE;
        return NULL;
    }
    if(i<0) return ParseTerm(ns, ne, str);
    node=AllocateNode();
    node->type=N_Math;
    node->sub=Pow;
    str[i]='\0';
    node->left =ParsePow(ns, line, str);
    node->right=ParseTerm(line, ne, str+i+1);
    return node;
}
Node* ParseIncrement(int ns, int ne, char* str)
{
    int i;
    char msg[256];
    Node* node;
    StripNewLines(&ns, &ne, &str);
    if(str[0]=='\0') return NULL;
    if(str[0]=='!'){
        if(str[1]=='\0'){
            sprintf(msg, E_NoRTerm, "!");
            ParseError(ns, msg);
            return NULL;
        }
        node=AllocateNode();
        node->type=N_Not;
        node->right=ParseIncrement(ns, ne, str+1);
        return node;
    }else if(str[0]=='+'){
        if(str[1]=='\0'){
            sprintf(msg, E_NoRTerm, "+");
            ParseError(ns, msg);
            return NULL;
        }
        if(str[1]=='+'){
            if(str[2]=='\0'){
                sprintf(msg, E_NoRTerm, "++");
                ParseError(ns, msg);
                return NULL;
            }
            node=AllocateNode();
            node->type=N_Incr;
            node->sub=Incr;
            node->right=ParseIncrement(ns, ne, str+2);
            return node;
        }else{
            node=AllocateNode();
            node->type=N_Plus;
            node->right=ParseIncrement(ns, ne, str+1);
            return node;
        }
    }else if(str[0]=='-'){
        if(str[1]=='\0'){
            sprintf(msg, E_NoRTerm, "-");
            ParseError(ns, msg);
            return NULL;
        }
        if(str[1]=='-'){
            if(str[2]=='\0'){
                sprintf(msg, E_NoRTerm, "--");
                ParseError(ns, msg);
                return NULL;
            }
            node=AllocateNode();
            node->type=N_Incr;
            node->sub=Decr;
            node->right=ParseIncrement(ns, ne, str+2);
            return node;
        }else{
            node=AllocateNode();
            node->type=N_Minus;
            node->right=ParseIncrement(ns, ne, str+1);
            return node;
        }
    }
    i=strlen(str)-1;
    if(str[i]=='+' && str[i-1]=='+'){
        str[i-1]='\0';
        node=AllocateNode();
        node->type=N_Incr;
        node->sub=Incr;
        node->left=ParseIncrement(ns, ne, str);
        return node;
    }else if(str[i]=='-' && str[i-1]=='-'){
        str[i-1]='\0';
        node=AllocateNode();
        node->type=N_Incr;
        node->sub=Decr;
        node->left=ParseIncrement(ns, ne, str);
        return node;
    }else{
        return ParsePow(ns, ne, str);
    }
}
Node* ParseAsterisk(int ns, int ne, char* str)
{
    int i, line;
    char msg[256];
    Node* node;
    StripNewLines(&ns, &ne, &str);
    if(str[0]=='\0') return NULL;
    if(str[0]=='*' || str[0]=='/' || str[0]=='%'){
/*        str[1]='\0';
        sprintf(msg, E_NoLTerm, str);
        ParseError(ns, msg);
        return NULL;*/
        return ParseToElement(ns, ne, str);
    }
    i=strlen(str)-1;  line=ne;
    if(str[i]=='*' || str[i]=='/' || str[i]=='%'){
/*        sprintf(msg, E_NoRTerm, str+i);
        ParseError(ne, msg);
        return NULL;*/
        return ParseToElement(ns, ne, str);
    }
    i=SearchFromEnd(&line, i, "*/%", str);
    if(err){
        err=FALSE;
        return NULL;
    }
    if(i<0) return ParseIncrement(ns, ne, str);
    node=AllocateNode();
    node->type=N_Math;
    if(str[i]=='*'){
        node->sub=Mul;
    }else if(str[i]=='/'){
        node->sub=Div;
    }else{
        node->sub=Mod;
    }
    str[i]='\0';
    node->left =ParseAsterisk(ns, line, str);
    node->right=ParseIncrement(line, ne, str+i+1);
    return node;
}
Node* ParsePlus(int ns, int ne, char* str)
{
    int i, line;
    char msg[256];
    Node* node;
    StripNewLines(&ns, &ne, &str);
    if(str[0]=='\0') return NULL;
    i=strlen(str)-1;  line=ne;
    if((str[i]=='+' || str[i]=='-') && 0<i && str[i-1]!=str[i]){
        sprintf(msg, E_NoRTerm, str+i);
        ParseError(ne, msg);
        return NULL;
    }
    while(TRUE){
        i=SearchFromEnd(&line, i, "+-", str);
        if(err){
            err=FALSE;
            return NULL;
        }
        if(i<=0) return ParseAsterisk(ns, ne, str);
        if(str[i-1]!=str[i] && str[i]!=str[i+1]) break;
        i--;
    }
    node=AllocateNode();
    node->type=N_Math;
    if(str[i]=='+'){
        node->sub=Add;
    }else{
        node->sub=Sub;
    }
    str[i]='\0';
    node->left =ParsePlus(ns, line, str);
    node->right=ParseAsterisk(line, ne, str+i+1);
    return node;
}
Node* ParseCommand(int ns, int ne, char* str)
{
    int i, ls=ns, le=ns;
    Node* nd;
    Node* node;
    Element* el;
    List* list;
    list=ToList(NULL);
    StripNewLines(&le, &ne, &str);
    if(str[0]=='\0') return NULL;
    while(*str!='\0'){
        ls=le;
        i=SearchFromBegining(&le, 0, " ", str);
        if(err){
            FreeTmpList(list);
            err=FALSE;
            return NULL;
        }
        if(str[i]==' '){
            str[i]='\0';  i++;
        }
        nd=ParsePlus(ls, le, str);
        if(nd && nd->type==N_Element){
            el=nd->el;  free(nd);
        }else{
            el=(Element*)nd;
        }
        AddToList(list, el);
        str+=i;
        StripNewLines(&le, &ne, &str);
    }
    node=AllocateNode();
    node->type=N_Command;
    node->el=(Element*)list;
    return node;
}
Node* ParseSentence(int ns, int ne, char* str)
{
    StripNewLines(&ns, &ne, &str);
    if(IsCommandForm(str)){
        return ParseCommand(ns, ne, str);
    }else{
        return ParsePlus(ns, ne, str);
    }
}
Node* ParseCompare(int ns, int ne, char* str)
{
    int i, line;
    char msg[256];
    Node* node;
    StripNewLines(&ns, &ne, &str);
    if(str[0]=='\0') return NULL;
    if((str[0]=='<' || str[0]=='>') && str[1]!=str[0]){
        if(str[1]=='='){
            str[2]='\0';
        }else{
            str[1]='\0';
        }
        sprintf(msg, E_NoLTerm, str);
        ParseError(ns, msg);
        return NULL;
    }
    i=strlen(str)-1;  line=ne;
    if(str[i]=='=') i--;
    if(str[i]=='<' || str[i]=='>'){
        sprintf(msg, E_NoRTerm, str+i);
        ParseError(ne, msg);
        return NULL;
    }
    while(TRUE){
        i=SearchFromEnd(&line, i, "<>", str);
        if(err){
            err=FALSE;
            return NULL;
        }
        if(i<0) return ParseSentence(ns, ne, str);
        if(0<i && str[i-1]!=str[i] && str[i]!=str[i+1]) break;
        i--;
    }
    node=AllocateNode();
    node->type=N_COMP;
    if(str[i+1]=='='){
        if(str[i]=='<'){
            node->sub=LE;
        }else{
            node->sub=GE;
        }
        str[i]='\0';  i++;
    }else{
        if(str[i]=='<'){
            node->sub=LT;
        }else{
            node->sub=GT;
        }
    }
    str[i]='\0';
    node->left =ParseCompare(ns, line, str);
    node->right=ParseSentence(line, ne, str+i+1);
    return node;
}
Node* ParseEqual(int ns, int ne, char* str)
{
    int i, line;
    char msg[256];
    Node* node;
    StripNewLines(&ns, &ne, &str);
    if(str[0]=='\0') return NULL;
    if((str[0]=='=' || str[0]=='!') && str[1]=='='){
        str[2]='\0';
        sprintf(msg, E_NoLTerm, str);
        ParseError(ns, msg);
        return NULL;
    }
    i=strlen(str)-1;  line=ne;
    if(str[i]=='=') i--;
    if(str[i]=='=' || str[i]=='!'){
        sprintf(msg, E_NoRTerm, str+i);
        ParseError(ne, msg);
        return NULL;
    }
    while(TRUE){
        i=SearchFromEnd(&line, i, "=", str);
        if(err){
            err=FALSE;
            return NULL;
        }
        if(i<0) return ParseCompare(ns, ne, str);
        if(0<i && (str[i-1]=='=' || str[i-1]=='!')) break;
        i--;
    }
    node=AllocateNode();
    node->type=N_COMP;
    if(str[i-1]=='='){
        node->sub=EQ;
    }else{
        node->sub=NE;
    }
    str[i]='\0';  str[i-1]='\0';
    node->left =ParseEqual(ns, line, str);
    node->right=ParseCompare(line, ne, str+i+1);
    return node;
}
Node* ParseAND(int ns, int ne, char* str)
{
    int i, line;
    Node* node;
    StripNewLines(&ns, &ne, &str);
    if(str[0]=='\0') return NULL;
    if(str[0]=='&' && str[1]=='&'){
        char msg[256];
        sprintf(msg, E_NoLTerm, "&&");
        ParseError(ns, msg);
        return NULL;
    }
    i=strlen(str)-1;  line=ne;
    if(str[i]=='&' && str[i-1]=='&'){
        char msg[256];
        sprintf(msg, E_NoRTerm, "&&");
        ParseError(ne, msg);
        return NULL;
    }
    while(TRUE){
        i=SearchFromEnd(&line, i, "&", str);
        if(i<0) return ParseEqual(ns, ne, str);
        if(err){
            err=FALSE;
            return NULL;
        }
        if(0<i && str[i-1]=='&') break;
        i--;
    }
    str[i]='\0';  str[i-1]='\0';
    node=AllocateNode();
    node->type=N_AND;
    node->left =ParseAND(ns, line, str);
    node->right=ParseEqual(line, ne, str+i+1);
    return node;
}
Node* ParseOR(int ns, int ne, char* str)
{
    int i, line;
    Node* node;
    StripNewLines(&ns, &ne, &str);
    if(str[0]=='\0') return NULL;
    if(str[0]=='|' && str[1]=='|'){
        char msg[256];
        sprintf(msg, E_NoLTerm, "||");
        ParseError(ns, msg);
        return NULL;
    }
    i=strlen(str)-1;  line=ne;
    if(str[i]=='|' && str[i-1]=='|'){
        char msg[256];
        sprintf(msg, E_NoRTerm, "||");
        ParseError(ne, msg);
        return NULL;
    }
    while(TRUE){
        i=SearchFromEnd(&line, i, "|", str);
        if(err){
            err=FALSE;
            return NULL;
        }
        if(i<0) return ParseAND(ns, ne, str);
        if(0<i && str[i-1]=='|') break;
        i--;
    }
    str[i]='\0';  str[i-1]='\0';
    node=AllocateNode();
    node->type=N_OR;
    node->left =ParseOR(ns, line, str);
    node->right=ParseAND(line, ne, str+i+1);
    return node;
}
Node* ParseSubstLeft(int ns, int ne, char* str)
{
    StripNewLines(&ns, &ne, &str);
    return ParseOR(ns, ne, str);
}
Node* ParseSubstitution(int ns, int ne, char* str)
{
    int i, line;
    Node* node;
    Node* left;
    StripNewLines(&ns, &ne, &str);
    if(str[0]=='\0') return NULL;
    if(str[0]=='=' && str[1]!='='){
        char msg[256];
        sprintf(msg, E_NoLTerm, "=");
        ParseError(ns, msg);
        return NULL;
    }
    i=strlen(str)-1;
    if(str[i]=='=' && str[i-1]!='='){
        char msg[256];
        sprintf(msg, E_NoRTerm, "=");
        ParseError(ne, msg);
        return NULL;
    }
    i=0;  line=ns;
    while(TRUE){
        i=SearchFromBegining(&line, i, "=", str);
        if(err){
            err=FALSE;
            return NULL;
        }
        if(str[i]=='\0') return ParseOR(ns, ne, str);
        if(str[i+1]!='=' && str[i-1]!='=' && str[i-1]!='!'
/*           && str[i-1]!='+' && str[i-1]!='-'
           && str[i-1]!='*' && str[i-1]!='/'*/
           && str[i-1]!='<' && str[i-1]!='>') break;
        i++;
    }
    str[i]='\0';
    node=AllocateNode();
    node->type=N_Subst;
    switch(str[i-1]){
      case '+':
        node->sub=Add;
        str[i-1]='\0';
        break;
      case '-':
        node->sub=Sub;
        str[i-1]='\0';
        break;
      case '*':
        node->sub=Mul;
        str[i-1]='\0';
        break;
      case '/':
        node->sub=Div;
        str[i-1]='\0';
        break;
      default:
        node->sub=None;
    }
    node->left =ParseSubstLeft(ns, line, str);
    node->right=ParseSubstitution(line, ne, str+i+1);
    return node;
}
Node* ParseIf(int ns, int ne, char* str)
{
    int i, line;
    Node* node;
    StripNewLines(&ns, &ne, &str);
    line=ns;
    node=AllocateNode();
    node->type=N_If;
    if(str[0]=='('){
        i=SearchFromBegining(&line, 0, ")", str);
        if(err){
            err=FALSE;
            free(node);
            return NULL;
        }
        str[i]='\0';
        node->left=ParseList(ns, line, str+1);
        str+=i+1;
    }else if(str[0]=='{'){
        i=SearchFromBegining(&line, 0, "}", str);
        if(err){
            err=FALSE;
            free(node);
            return NULL;
        }
        str[i]='\0';
        node->left=ParseSentence(ns, line, str+1);
        str+=i+1;
    }else{
        i=SearchFromBegining(&line, 0, " ", str);
        if(str[i]=='\0' || err){
            err=FALSE;
            free(node);
            return NULL;
        }
        str[i]='\0';
        node->left=ParseSentence(ns, line, str);
        str+=i+1;
    }
    ns=line;
    StripNewLines(&ns, &ne, &str);
    line=ns;
    if(str[0]!='{'){
        node->el=(Element*)ParseSubstitution(ns, ne, str);
        return node;
    }
    i=SearchFromBegining(&line, 0, "}", str);
    if(err){
        err=FALSE;
        FreeTmpNode(node);
        return NULL;
    }
    str[i]='\0';
    node->el=(Element*)ParseSemicolon(ns, line, str+1);
    str+=i+1;
    StripNewLines(&line, &ne, &str);
    if(str[0]=='\0') return node;
    if(!IsElseBlock(str)){
        char msg[256];
        sprintf(msg, E_ExTermAF, "if block");
        ParseError(line, msg);
        FreeTmpNode(node);
        return NULL;
    }
    str+=4;
    ns=line;
    StripNewLines(&ns, &ne, &str);
    if(str[0]!='{'){
        node->right=ParseBlock(ns, ne, str);
    }else{
        i=SearchFromBegining(&line, 0, "}", str);
        if(err){
            err=FALSE;
            FreeTmpNode(node);
            return NULL;
        }else if(str[i+1]!='\0'){
            char msg[256];
            sprintf(msg, E_ExTermAF, "else block");
            ParseError(line, msg);
            FreeTmpNode(node);
            return NULL;
        }
        str[i]='\0';
        node->right=ParseSemicolon(ns, ne, str+1);
    }
    return node;
}
Node* ParseWhile(int ns, int ne, char* str)
{
    int i, line;
    Node* node;
    StripNewLines(&ns, &ne, &str);
    line=ns;
    node=AllocateNode();
    node->type=N_While;
    if(str[0]=='('){
        i=SearchFromBegining(&line, 0, ")", str);
        if(err){
            err=FALSE;
            free(node);
            return NULL;
        }
        str[i]='\0';
        node->left=ParseList(ns, line, str+1);
        str+=i+1;
    }else if(str[0]=='{'){
        i=SearchFromBegining(&line, 0, "}", str);
        if(err){
            err=FALSE;
            free(node);
            return NULL;
        }
        str[i]='\0';
        node->left=ParseSentence(ns, line, str+1);
        str+=i+1;
    }else{
        i=SearchFromBegining(&line, 0, " ", str);
        if(str[i]=='\0' || err){
            err=FALSE;
            free(node);
            return NULL;
        }
        str[i]='\0';
        node->left=ParseSentence(ns, line, str);
        str+=i+1;
    }
    ns=line;
    StripNewLines(&ns, &ne, &str);
    if(err){
        err=FALSE;
        FreeTmpNode(node);
        return NULL;
    }else if(str[0]!='{'){
        node->right=ParseSubstitution(ns, ne, str);
        return node;
    }
    line=ns;
    i=SearchFromBegining(&line, 0, "}", str);
    if(err){
        err=FALSE;
        FreeTmpNode(node);
        return NULL;
    }else if(str[i+1]!='\0'){
        char msg[256];
        sprintf(msg, E_ExTermAF, "while block");
        ParseError(line, msg);
        FreeTmpNode(node);
        return NULL;
    }
    str[i]='\0';
    node->right=ParseSemicolon(ns, line, str+1);
    return node;
}
Element* ParseForCondition(int ns, int ne, char* str)
{
    int i, line;
    List* list;
    StripNewLines(&ns, &ne, &str);
    list=ToList(NULL);
    line=ne;
    i=SearchFromEnd(&line, strlen(str)-1, ";", str);
    if(err){
        err=FALSE;
        return NULL;
    }
    if(i<0) return NULL;
    str[i]='\0';
    PushToList(list, (Element*)ParseSemicolon(line, ne, str+i+1));
    ne=line;
    line=ns;
    i=SearchFromBegining(&line, 0, ";", str);
    if(err || str[i]=='\0'){
        err=FALSE;
        FreeTmpList(list);
        return NULL;
    }
    str[i]='\0';
    PushToList(list, (Element*)ParseSemicolon(line, ne, str+i+1));
    PushToList(list, (Element*)ParseSemicolon(ns, line, str));
    return (Element*)list;
}
Node* ParseFor(int ns, int ne, char* str)
{
    int i, line;
    Node* node;
    StripNewLines(&ns, &ne, &str);
    line=ns;
    node=AllocateNode();
    node->type=N_For;
    if(str[0]=='('){
        i=SearchFromBegining(&line, 0, ")", str);
        if(err){
            err=FALSE;
            return NULL;
        }
        str[i]='\0';
        node->el=ParseForCondition(ns, line, str+1);
        str+=i+1;
    }else if(str[0]=='{'){
        i=SearchFromBegining(&line, 0, "}", str);
        if(err){
            err=FALSE;
            return NULL;
        }
        str[i]='\0';
        node->el=ParseForCondition(ns, line, str+1);
        str+=i+1;
    }
    if(node->el==NULL){
        char msg[256];
        sprintf(msg, E_FewSents, "condition of for block");
        ParseError(line, msg);
        FreeTmpNode(node);
        return NULL;
    }
    ns=line;
    StripNewLines(&ns, &ne, &str);
    if(str[0]!='{'){
        node->right=ParseSubstitution(ns, ne, str);
        return node;
    }
    line=ns;
    i=SearchFromBegining(&line, 0, "}", str);
    if(err){
        err=FALSE;
        FreeTmpNode(node);
        return NULL;
    }
    if(str[i+1]!='\0'){
        char msg[256];
        sprintf(msg, E_ExTermAF, "for block");
        ParseError(line, msg);
        FreeTmpNode(node);
        return NULL;
    }
    str[i]='\0';
    node->right=ParseSemicolon(ns, line, str+1);
    return node;
}
Node* ParseSubroutine(int ns, int ne, char* str)
{
    int i, line;
    char* name;
    Element* blk;
    StripNewLines(&ns, &ne, &str);
    line=ns;
    i=SearchFromBegining(&line, 0, " ", str);
    if(str[i]=='\0' || err){
        err=FALSE;
        return NULL;
    }
    str[i]='\0';
    name=str;
    str+=i+1;
    ns=line;
    StripNewLines(&ns, &ne, &str);
    if(err){
        err=FALSE;
        return NULL;
    }else if(str[0]!='{'){
        blk=BlockElement(ParseSubstitution(ns, ne, str));
        AddToAsArrayVar(V_Sub, StringElement(name), blk);
        return NULL;
    }
    line=ns;
    i=SearchFromBegining(&line, 0, "}", str);
    if(err){
        err=FALSE;
        return NULL;
    }else if(str[i+1]!='\0'){
        char msg[256];
        sprintf(msg, E_ExTermAF, "subroutine definition");
        ParseError(line, msg);
        return NULL;
    }
    str[i]='\0';
    blk=BlockElement(ParseSemicolon(ns, ne, str+1));
    AddToAsArrayVar(V_Sub, StringElement(name), blk);
    return NULL;
}
Node* ParseBlock(int ns, int ne, char* str)
{
    int i;
    StripNewLines(&ns, &ne, &str);
    if(str[0]=='\0') return NULL;
    if(IsIfBlock(str)){
        return ParseIf(ns, ne, str+2);
    }else if(IsWhileBlock(str)){
        return ParseWhile(ns, ne, str+5);
    }else if(IsForBlock(str)){
        return ParseFor(ns, ne, str+3);
    }else if((i=IsSubroutine(str))){
        return ParseSubroutine(ns, ne, str+i);
    }else{
        return ParseSubstitution(ns, ne, str);
    }
}
Node* ParseSemicolon(int ns, int ne, char* str)
{
    int i, line;
    Node* node;
    StripNewLines(&ns, &ne, &str);
    StripCharacters(" ;", &str);
    if(str[0]=='\0') return NULL;
    i=strlen(str)-1;
    line=ne;
    i=SearchFromEnd(&line, i, ";", str);
    if(err){
        err=FALSE;
        return NULL;
    }
    if(i<0) return ParseBlock(ns, ne, str);
    str[i]='\0';
    node=AllocateNode();
    node->type=N_Semicolon;
    node->left =ParseSemicolon(ns, line, str);
    node->right=ParseBlock(line, ne, str+i+1);
    return node;
}

int SeekVariable(char* str, char* var, Element** el)
{
    int i;
    char buf[256];
    for(i=0; IsVarWord(str[i]); i++) buf[i]=str[i];
    buf[i]='\0';
    strcpy(var, buf);
    while(buf[0]!='\0' && !(VariableExists(buf, el))){
        i--;  buf[i]='\0';
    }
    if(buf[0]=='\0'){
        return FALSE;
    }else{
        strcpy(var, buf);
        return TRUE;
    }
}
Element* EvaluateString(Element* el)
{
    int i, j, nbuf;
    char quote=0;
    char* str;
    char* buf;
    Element* ret;
    str=el->string.val;
    nbuf=strlen(str)+1;
    buf=(char*)malloc(nbuf*sizeof(char));
    j=0;
    for(i=0; str[i]!='\0'; i++){
        if(str[i]==92){
            i++;
            if(quote){
                buf[j]=EscapedCharacter(str[i]);
            }else{
                buf[j]=str[i];
            }
            j++;
        }else if(str[i]=='$'){
            char var[256];
            Element* el;
            if(quote==39){
                buf[j]=str[i];  j++;
                continue;
            }
            if(SeekVariable(str+i, var, &el)){
                char* s;
                buf[j]='\0';
                s=ToString(el);
                if(strlen(var)<strlen(s)){
                    nbuf+=strlen(s);
                    buf=(char*)realloc(buf, nbuf);
                }
                strcat(buf, s);
                if(el && el->type!=STR) free(s);
                j=strlen(buf);
            }else{
                char msg[256];
                sprintf(msg, E_NoSuchVar, var);
                ExecError(msg);
            }
            i+=strlen(var)-1;
        }else if(quote){
            if(str[i]==quote){
                quote=0;
            }else{
                buf[j]=str[i];  j++;
            }
        }else if(str[i]==34){
            quote=34;
        }else if(str[i]==39){
            quote=39;
        }else{
            buf[j]=str[i];  j++;
        }
    }
    buf[j]='\0';
    ret=StringElement(buf);
    free(buf);
    return ret;
}
Element* EvaluateList(Element* el)
{
    List* le;
    List* ret;
    ret=ToList(NULL);
    le=el->list.next;
    while(le){
        if(le->el==NULL){
            AddToList(ret, NULL);
        }else if(le->el->type==VAR){
            AddToList(ret, ExpandVariable(le->el));
        }else if(le->el->type==STR){
            AddToList(ret, EvaluateString(le->el));
        }else if(le->el->type==LIST){
            AddToList(ret, EvaluateList(le->el));
        }else if(IsNode(le->el)){
            AddToList(ret, ExecuteNodeTree((Node*)(le->el), NULL));
        }else{
            AddToList(ret, CopyElement(le->el));
        }
        le=le->next;
    }
    return (Element*)ret;
}
Element* ExpandVariable(Element* el)
{
    Element* ret;
    if(VariableExists(el->string.val, &ret)){
        return ret;
    }else{
        char msg[256];
        sprintf(msg, E_NoSuchVar, el->string.val);
        ExecError(msg);
        return NULL;
    }
}
void ExpandVarArguments(List* list)
{
    Element* tmp;
    List* le;
    le=list->next;
    while(le){
        if(le->el && le->el->type==VAR){
            tmp=le->el;
            le->el=ExpandVariable(le->el);
            FreeTmpElement(tmp);
        }
        le=le->next;
    }
}
void EvaluateAlias(List* list)
{
    int i;
    List* le;
    Element* el;
    le=list->next;
    if(!le) return;
    el=le->el;
    if(!el) return;
    if(el->type==STR && el->string.val[0]=='\\') return;
    el=GetAsArrayValue(V_Alias, el);
    if(!el || el->type!=LIST) return;
    FreeTmpElement(PopFromList(list));
    for(i=ListLength((List*)el); 0<i; i--)
            PushToList(list, CopyElement(NthElement(i, (List*)el)));
}
List* EvaluateArguments(List* list)
{
    List* le;
    List* ret;
    ret=ToList(NULL);
    le=list->next;
    if(le==NULL) return ret;
    AddToList(ret, CopyElement(le->el));
    le=le->next;
    while(le){
        if(le->el==NULL){
            AddToList(ret, NULL);
        }else if(le->el->type==STR){
            AddToList(ret, EvaluateString(le->el));
        }else if(le->el->type==LIST){
            AddToList(ret, EvaluateList(le->el));
        }else if(IsNode(le->el)){
            AddToList(ret, ExecuteNodeTree((Node*)(le->el), NULL));
        }else{
            AddToList(ret, CopyElement(le->el));
        }
        le=le->next;
    }
    return ret;
}
void InitializeBlock(List* argv, Block* blk)
{
    int i;
    static char* glvars[] =
            {V_Prompt, V_System, V_History, V_Alias, V_Sub};
    static int nvars=sizeof(glvars)/sizeof(*glvars);
    if(blk->vl==NULL) blk->vl=AllocateVariable("");
    SetCurrentVarList(blk->vl);
    for(i=0; i<nvars; i++) Globalize(glvars[i]);
    if(argv){
        SetVariable(V_Argc, IntegerElement(ListLength(argv)));
        SetVariable(V_Argv, CopyElement((Element*)argv));
    }
}
Element* ExecuteBlock(List* argv, Block* blk)
{
    Element* ret;
    if(blk==NULL) return NULL;
    InitializeBlock(argv, blk);
    ret=ExecuteNodeTree(blk->node, NULL);
    if(ret && ret->undef.tmp==FALSE) ret=CopyElement(ret);
    FreeVariableList(blk->vl);
    SetCurrentVarList(GlobalVarList());
    return ret;
}
Element* ExecuteSubroutine(char* name, List* argv, Block* blk)
{
    char nameback[256];
    Element* ret;
    GetSubName(nameback);
    SetSubName(name);
    ret=ExecuteBlock(argv, blk);
    ClearReturnSignal();
    SetSubName(nameback);
    return ret;
}
Element* ExecuteCommand(List* list)
{
    Element* el;
    Element* ret=NULL;
    CommandList cm;
    list=EvaluateArguments(list);
    EvaluateAlias(list);
    el=GetAsArrayValue(V_Sub, list->next->el);
    if(el && el->type==BLOCK){
        ExpandVarArguments(list);
        ret=ExecuteSubroutine(ToString(list->next->el),
                              list, (Block*)el);
        return ret;
    }
    cm=NameToCommand(ToString(list->next->el));
    if(cm.func){
        int i, argc;
        Element** argv;
        List* le;
        if(!IsVarCommand(cm)) ExpandVarArguments(list);
        argc=ListLength(list);
        argv=(Element**)malloc(argc*sizeof(Element*));
        for(i=0; i<argc; i++){
            argv[i]=NthElement(i+1, list);
            if(!argv[i]) argv[i]=UndefElement();
        }
        ret=cm.func(argc, argv);
        free(argv);
    }else if((el=VarNameToElement(V_System))
             && ToBoolean(el)){
        system(ToString((Element*)list));
    }else{
        CommandError(ToString(list->next->el), E_ComNotFound);
    }
    FreeTmpList(list);
    return ret;
}

Element** PrepareElement(Node* node)
{
    Element** ret;
    Element* right;
    Element** lf;
    if(node==NULL) return NULL;
    if(node->type==N_Element && node->el && node->el->type){
        ret=PrepareVariable(node->el->string.val);
        return ret;
    }else if(node->type==N_Index){
        int i;
        Element* left;
        right=ExecuteNodeTree(node->right, node);
        i=ToInteger(right);
        FreeTmpElement(right);
        if(i<0) return NULL;
        if(node->left==NULL){
            return NULL;
        }else if(node->left->type==N_Period){
            left=ExecuteNodeTree(node->left, node);
        }else{
            lf=PrepareElement(node->left);
            if(lf==NULL) return NULL;
            if(*lf==NULL || (*lf)->type!=LIST){
                FreeElement(*lf);
                *lf=ListElement(0, NULL);
                SetTmpVal(*lf, FALSE);
            }
            left=*lf;
        }
        return PrepareNthElement(i+1, (List*)left);
    }else if(node->type==N_Key){
        right=ExecuteNodeTree(node->right, node);
        lf=PrepareElement(node->left);
        if(lf==NULL){
            return NULL;
        }
        if(*lf==NULL || (*lf)->type!=LIST){
            FreeElement(*lf);
            *lf=ListElement(0, NULL);
            SetTmpVal(*lf, FALSE);
        }
        ret=PrepareKeyToValue((List*)(*lf), right);
        return ret;
    }
    return NULL;
}
void SetNodeVariable(Node* node, Element* el)
{
    if(node==NULL){
        return;
    }
    if(node->type==N_Element && node->el && node->el->type==VAR){
        SetVariable(node->el->string.val, el);
    }else if(node->type==N_Index){
        int i;
        Element* right;
        Element* left;
        right=ExecuteNodeTree(node->right, node);
        i=ToInteger(right);
        FreeTmpElement(right);
        if(i<0){
            return;
        }
        if(node->left==NULL){
            return;
        }else if(node->left->type==N_Period){
            left=ExecuteNodeTree(node->left, node);
        }else{
            Element** lf;
            lf=PrepareElement(node->left);
            if(lf==NULL){
                return;
            }
            if(*lf==NULL){
                *lf=ListElement(0, NULL);
            }else if((*lf)->type!=LIST && !IsArray(*lf)){
                FreeElement(*lf);
                *lf=ListElement(0, NULL);
            }
            left=*lf;
            SetTmpVal(left, FALSE);
        }
        if(left==NULL){
        }else if(left->type==LIST){
            SetTmpVal(el, FALSE);
            SetNthElement(i+1, (List*)left, el);
        }else if(left->type==IARRAY){
            SetNthValueI(i, (IArray*)left, ToInteger(el));
        }else if(left->type==DARRAY){
            SetNthValueD(i, (DArray*)left, ToDouble(el));
        }
    }else if(node->type==N_Period){
        Element* left;
        left=ExecuteNodeTree(node->left, node);
        if(left==NULL) return;
        SetStructMember(left, node->el->string.val, el);
        FreeTmpElement(left);
    }else if(node->type==N_Element && node->el->type==LIST){
        Element* tmp;
        List* le;
        le=node->el->list.next;
        if(el && el->type==LIST){
            Element* val;
            List* le1;
            le1=el->list.next;
            while(le){
                if(le1){
                    val=le1->el;
                    le1=le1->next;
                }else{
                    val=NULL;
                }
                SetNodeVariable((Node*)(le->el), val);
                le=le->next;
            }
        }else{
            if(le) SetNodeVariable((Node*)(le->el), el);
        }
    }else{
        Element** left;
        left=PrepareElement(node);
        if(left){
            FreeElement(*left);
            *left=el;
        }
    }
}
Element* IncrementNode(Node* node)
{
    Element* el;
    Element* tmp;
    Element* ret;
    Node* nd;
    if(node->left){
        nd=node->left;
    }else if(node->right){
        nd=node->right;
    }else{
        return NULL;
    }
    if(nd->type==N_Element && nd->el && nd->el->type==VAR){
        ret=VarNameToElement(nd->el->string.val);
        if(node->left){
            ret=CopyElement(ret);
            SetVariable(nd->el->string.val,
                        IncrElement(ret, node->sub));
        }else{
            ret=IncrElement(ret, node->sub);
            SetVariable(nd->el->string.val, ret);
        }
    }else if(nd->type==N_Index){
        int i;
        Element* right;
        Element* left;
        right=ExecuteNodeTree(nd->right, node);
        i=ToInteger(right);
        FreeTmpElement(right);
        if(nd->left==NULL){
            return NULL;
        }else if(nd->left->type==N_Period){
            left=ExecuteNodeTree(nd->left, nd);
        }else{
            Element** lf;
            lf=PrepareElement(nd->left);
            if(lf==NULL || *lf==NULL) return NULL;
            if((*lf)->type!=LIST && !IsArray(*lf)) return NULL;
            left=*lf;
        }
        if(left->type==LIST){
            ret=NthElement(i+1, (List*)left);
            if(ret==NULL) return NULL;
            if(node->left){
                ret=CopyElement(ret);
                tmp=IncrElement(ret, node->sub);
                SetTmpVal(tmp, left->list.tmp);
                SetNthElement(i+1, (List*)left, tmp);
            }else{
                ret=IncrElement(ret, node->sub);
                SetTmpVal(ret, left->list.tmp);
                SetNthElement(i+1, (List*)left, ret);
            }
        }else if(left->type==IARRAY){
            int v;
            if(left->iarray.num-1<i) return NULL;
            if(node->left){
                ret=IntegerElement(left->iarray.val[i]);
                left->iarray.val[i]++;
            }else{
                left->iarray.val[i]++;
                ret=IntegerElement(left->iarray.val[i]);
            }
        }else if(left->type==DARRAY){
            if(left->darray.num-1<i) return NULL;
            if(node->left){
                ret=DoubleElement(left->darray.val[i]);
                left->darray.val[i]++;
            }else{
                left->darray.val[i]++;
                ret=DoubleElement(left->darray.val[i]);
            }
        }
    }else if(nd->type==N_Key){
        Element** left;
        left=PrepareElement(nd);
        if(left){
            ret=*left;
            *left=IncrElement(ret, node->sub);
            SetTmpVal(ret, TRUE);  SetTmpVal(*left, FALSE);
            if(node->right){
                FreeElement(ret);
                ret=*left;
            }
        }else{
            ret=NULL;
        }
    }else if(nd->type==N_Period){
        Element* left;
        left=ExecuteNodeTree(nd->left, nd);
        ret=StructMember(left, nd->el->string.val);
        tmp=IncrElement(ret, node->sub);
        if(!tmp){
        }else if(node->right){
            FreeTmpElement(ret);
            ret=tmp;
            SetStructMember(left, nd->el->string.val, ret);
        }else{
            ret=CopyElement(ret);
            SetStructMember(left, nd->el->string.val, tmp);
        }
    }else{
        ret=ExecuteNodeTree(nd, NULL);
        if(node->right){
            Element* tmp;
            tmp=IncrElement(ret, node->sub);
            FreeTmpElement(ret);
            ret=tmp;
        }
    }
    return ret;
}
Element* ExecuteNodeTree(Node* node, Node* parent)
{
    int i;
    char key;
    Element* ret  =NULL;
    Element* left =NULL;
    Element* right=NULL;
    if(node==NULL) return NULL;
    if(AnySignal()) return NULL;
    if(node->type==N_Element){
        if(node->el==NULL){
            ret=NULL;
        }else if(node->el->type==VAR){
            ret=ExpandVariable(node->el);
        }else if(node->el->type==STR){
            ret=EvaluateString(node->el);
        }else if(node->el->type==LIST){
            ret=EvaluateList(node->el);
        }else if(node->el->type==BLOCK){
            if(parent==NULL || parent->type==N_Semicolon){
                ret=ExecuteBlock(NULL, (Block*)(node->el));
            }else{
                ret=CopyElement(node->el);
            }
        }else if(IsNode(node->el)){
            ret=ExecuteNodeTree((Node*)(node->el), node);
        }else{
            ret=CopyElement(node->el);
        }
    }else if(node->type==N_Index){
        left =ExecuteNodeTree(node->left,  node);
        right=ExecuteNodeTree(node->right, node);
        if(right==NULL){
            ExecError(E_NoIndex);
        }else if(right->type!=INT){
            ExecError(E_NoIntIndex);
        }else{
            i=ToInteger(right);
            if(left==NULL){
                ret=NULL;
            }else if(left->type==LIST){
                ret=NthElement(i+1, (List*)left);
                if(left->undef.tmp) ret=CopyElement(ret);
            }else if(left->type==IARRAY){
                ret=NthValueI(i, (IArray*)left);
            }else if(left->type==DARRAY){
                ret=NthValueD(i, (DArray*)left);
            }else if(i==0){
                ret=left;
            }else{
                ret=NULL;
            }
        }
        FreeTmpElement(left);  FreeTmpElement(right);
    }else if(node->type==N_Key){
        left =ExecuteNodeTree(node->left,  node);
        right=ExecuteNodeTree(node->right, node);
        if(left && left->type==LIST){
            ret=KeyToValue((List*)left, right);
        }else{
            ret=NULL;
        }
        FreeTmpElement(left);  FreeTmpElement(right);
    }else if(node->type==N_Period){
        left=ExecuteNodeTree(node->left, node);
        ret=StructMember(left, node->el->string.val);
    }else if(node->type==N_Not){
        right=ExecuteNodeTree(node->right, node);
        ret=IntegerElement(!ToBoolean(right));
        FreeTmpElement(right);
    }else if(node->type==N_Plus || node->type==N_Minus){
        right=ExecuteNodeTree(node->right, node);
        if(right && right->type==STR){
            char buf[256];
            if(node->type==N_Plus){
                sprintf(buf, "+%s", right->string.val);
            }else{
                sprintf(buf, "-%s", right->string.val);
            }
            ret=StringElement(buf);
            FreeTmpElement(right);
        }else{
            if(node->type==N_Plus){
                ret=right;
            }else{
                ret=MultiplyElements(IntegerElement(-1), right);
                FreeTmpElement(right);
            }
        }
    }else if(node->type==N_Incr){
        ret=IncrementNode(node);
    }else if(node->type==N_Math){
        left =ExecuteNodeTree(node->left,  node);
        right=ExecuteNodeTree(node->right, node);
        if(node->sub==Add){
            ret=AddElements(left, right);
        }else if(node->sub==Sub){
            ret=SubtractElements(left, right);
        }else if(node->sub==Mul){
            ret=MultiplyElements(left, right);
        }else if(node->sub==Div){
            ret=DivideElements(left, right);
        }else if(node->sub==Mod){
            ret=ModElements(left, right);
        }else if(node->sub==Pow){
            ret=PowElements(left, right);
        }else{
            ret=NULL;
        }
        FreeTmpElement(left);  FreeTmpElement(right);
    }else if(node->type==N_Command){
        ret=ExecuteCommand((List*)(node->el));
        PendingKeyPress(&key, NULL, NULL);
        if(!parent || parent->type!=N_Subst){
            SetDefaultVariable(ret);
        }
        ClearDefaultVariable();
    }else if(node->type==N_COMP){
        left =ExecuteNodeTree(node->left,  node);
        right=ExecuteNodeTree(node->right, node);
        ret=IntegerElement
                (CompareElements(node->sub, left, right));
        FreeTmpElement(left);  FreeTmpElement(right);
    }else if(node->type==N_AND){
        left=ExecuteNodeTree(node->left, node);
        if(!ToBoolean(left)){
            ret=IntegerElement(FALSE);
        }else{
            right=ExecuteNodeTree(node->right, node);
            ret=IntegerElement(ToBoolean(right));
            FreeTmpElement(right);
        }
        FreeTmpElement(left);
    }else if(node->type==N_OR){
        left=ExecuteNodeTree(node->left, node);
        if(ToBoolean(left)){
            ret=IntegerElement(TRUE);
        }else{
            right=ExecuteNodeTree(node->right, node);
            ret=IntegerElement(ToBoolean(right));
            FreeTmpElement(right);
        }
        FreeTmpElement(left);
    }else if(node->type==N_Subst){
        right=ExecuteNodeTree(node->right, node);
        if(node->sub){
            left=ExecuteNodeTree(node->left, node);
            if(node->sub==Add){
                ret=AddElements(left, right);
            }else if(node->sub==Sub){
                ret=SubtractElements(left, right);
            }else if(node->sub==Mul){
                ret=MultiplyElements(left, right);
            }else if(node->sub==Div){
                ret=DivideElements(left, right);
            }
            FreeTmpElement(right);
            FreeTmpElement(left);
        }else{
            ret=right;
        }
        if(ret && ret->undef.tmp){
            SetNodeVariable(node->left, ret);
        }else{
            SetNodeVariable(node->left, CopyElement(ret));
        }
    }else if(node->type==N_If){
        left=ExecuteNodeTree(node->left, node);
        if(ToBoolean(left)){
            ret=ExecuteNodeTree((Node*)(node->el), node);
        }else{
            ret=ExecuteNodeTree(node->right, node);
        }
        FreeTmpElement(left);
    }else if(node->type==N_While){
        while(!BreakSignal()){
            left=ExecuteNodeTree(node->left, node);
            if(ToBoolean(left)){
                FreeTmpElement(left);
                FreeTmpElement(ExecuteNodeTree(node->right, node));
            }else{
                FreeTmpElement(left);
                break;
            }
            ClearContinueSignal();
        }
        ClearBreakSignal();
    }else if(node->type==N_For){
        Node* tmp;
        Node* incr;
        Node* cond;
        tmp =(Node*)NthElement(1, (List*)(node->el));
        FreeTmpElement(ExecuteNodeTree(tmp, node));
        cond=(Node*)NthElement(2, (List*)(node->el));
        incr=(Node*)NthElement(3, (List*)(node->el));
        while(!BreakSignal()){
            left=ExecuteNodeTree(cond, node);
            if(ToBoolean(left)){
                FreeTmpElement(left);
                FreeTmpElement(ExecuteNodeTree(node->right, node));
            }else{
                FreeTmpElement(left);
                break;
            }
            ClearContinueSignal();
            FreeTmpElement(ExecuteNodeTree(incr, node));
        }
        ClearBreakSignal();
    }else if(node->type==N_Semicolon){
        ret=ExecuteNodeTree(node->left,  node);
        if(!AnySignal()){
            FreeTmpElement(ret);
            ret=ExecuteNodeTree(node->right, node);
        }
    }
    return ret;
}

void ProccessCommandLine(int n, char* str)
{
    Node* node;
    Element* ret;
    TabToSpace(str);
    node=ParseSemicolon(1, n, str);
    if(ParseErrorOccured()){
        FreeNode(node);
        ClearParseError();
        return;
    }
    ret=ExecuteNodeTree(node, NULL);
    FreeTmpElement(ret);
    FreeTmpNode(node);
}
